unit DeleteFrame;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OptionsManager;

type
  TAskOptionFrame = class(TFrame)
    RadioButtonDelete: TRadioButton;
    RadioButtonTrash: TRadioButton;
    RadioButtonKeep: TRadioButton;
    CheckBoxAsk: TCheckBox;
    LabelType: TLabel;
    procedure ChangeStat(Sender: TObject);
    procedure FrameClick(Sender: TObject);
  private
    FSetup: boolean;
    FOnChange: TNotifyEvent;
    procedure SetOnChange(const Value: TNotifyEvent);
    { Dclarations prives }
  public
    { Dclarations publiques }
    constructor Create(AOwner: TComponent); override;

    procedure SetValues(Value: TFileActions);
    function GetValues: TFileActions;
  published
    property OnChange: TNotifyEvent read FOnChange write SetOnChange;
  end;

implementation

{$R *.dfm}

{ TAskOptionFrame }

function TAskOptionFrame.GetValues: TFileActions;
begin
  Result.fcAskBefore := CheckBoxAsk.Checked;
  if RadioButtonDelete.Checked then Result.fcAction := fcaDelete else
  if RadioButtonTrash.Checked then Result.fcAction := fcaTrash else
  if RadioButtonKeep.Checked then Result.fcAction := fcaNone;
end;

procedure TAskOptionFrame.SetOnChange(const Value: TNotifyEvent);
begin
  FOnChange := Value;
end;

procedure TAskOptionFrame.SetValues(Value: TFileActions);
begin
  FSetup := True;
  case Value.fcAction of
    fcaDelete : RadioButtonDelete.Checked := True;
    fcaTrash  : RadioButtonTrash.Checked := True;
    fcaNone   : RadioButtonKeep.Checked := True;
  end;
  CheckBoxAsk.Checked := Value.fcAskBefore;
  FSetup := False;
end;

procedure TAskOptionFrame.ChangeStat(Sender: TObject);
begin
  if (not FSetup) and Assigned(FOnChange) then FOnChange(Self);
end;

procedure TAskOptionFrame.FrameClick(Sender: TObject);
begin
  FSetup := false;
end;

constructor TAskOptionFrame.Create(AOwner: TComponent);
begin
  inherited;
  FSetup := false;
end;

end.
