{ DONE 5 -cApplication :
BUG#0001 : 
Slction d'un lment vide -> provoque une xception !!! }
unit FileListForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Menus, Contnrs;

type
  TFormFileList = class(TForm)
    Label1: TLabel;
    ListViewAction: TListView;
    ButtonAccept: TButton;
    PopupMenuAction: TPopupMenu;
    Supprimer1: TMenuItem;
    Envoyerdanslacorbeille1: TMenuItem;
    Nerienfaire1: TMenuItem;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure ListViewActionChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure Nerienfaire1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject); 
    procedure PopupMenuActionPopup(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Dclarations prives }
    FList : TObjectList;
    FCorrespondance: array of Integer;
    procedure UpdateList;
  public
    { Dclarations publiques }
  end;

var
  FormFileList: TFormFileList;

procedure ModifiedActionList(const List: TObjectList; const Silent: boolean = false);

implementation

uses SearchObjectThread, FileTools, OptionsManager, SearchObject,
  SearchForm, resources, AppModule, JvTrayIcon;

{$R *.dfm}

function SelectAction(const Attr: string; var Ask: boolean): TAction;
var I  : Integer;
    Act: TAction;
    Q  : boolean;
begin
  if Length(Attr) = 0 then begin
    result := FormSearch.OptionsMgr.PersonalSearch.OrdinaryFiles.fcAction;
    Ask    := FormSearch.OptionsMgr.PersonalSearch.OrdinaryFiles.fcAskBefore;
  end else begin
    result := fcaDelete;
    Ask := False;
    for I := 1 to Length(Attr) do begin
      case Attr[I] of
        'A' : begin
          Act := FormSearch.OptionsMgr.PersonalSearch.ArchivedFiles.fcAction;
          Q   := FormSearch.OptionsMgr.PersonalSearch.ArchivedFiles.fcAskBefore;
        end;
        'R' : begin
          Act := FormSearch.OptionsMgr.PersonalSearch.ReadOnlyFiles.fcAction;
          Q   := FormSearch.OptionsMgr.PersonalSearch.ReadOnlyFiles.fcAskBefore;
        end;
        'H' : begin
          Act := FormSearch.OptionsMgr.PersonalSearch.HiddenFiles.fcAction;
          Q   := FormSearch.OptionsMgr.PersonalSearch.HiddenFiles.fcAskBefore;
        end;
        'S' : begin
          Act := FormSearch.OptionsMgr.PersonalSearch.SystemsFiles.fcAction;
          Q   := FormSearch.OptionsMgr.PersonalSearch.SystemsFiles.fcAskBefore;
        end;
        else begin
          Act := fcaNone;
          Q   := True;
        end;
      end;

      if(Ord(Result) < Ord(Act)) then
        Result := Act;
      Ask := Ask or Q;
    end;
  end;
end;

procedure ModifiedActionList(const List: TObjectList; const Silent: boolean = false);
var I: Integer;
    Ask: boolean;
begin
  FormFileList := TFormFileList.Create(Application);
  with FormFileList do begin
    FList := List;
    Ask := False;
    SetLength(FCorrespondance, FList.Count);
    for I := 0 to FList.Count - 1 do begin
      TFileInfo(FList[I]).Action := SelectAction(TFileInfo(FList[I]).FileAttr, TFileInfo(FList[I]).Ask);
      Ask := Ask or TFileInfo(FList[I]).Ask;
    end;
    UpdateList;
    if (not Silent) and Ask then
      ShowModal;
    Free;
  end;
end;

{ TFormFileList }

procedure TFormFileList.UpdateList;
var I, J: Integer;
begin
  ListViewAction.Items.BeginUpdate;
  try
    J := 0;
    ListViewAction.Clear;
    for I := 0 to FList.Count - 1 do begin
      if TFileInfo(FList[I]).Ask then begin
        with ListViewAction.Items.Add do begin
          Caption := TFileInfo(FList[I]).FileName;
          SubItems.Add(SizeToStr(TFileInfo(FList[I]).FileSize));
          SubItems.Add(TFileInfo(FList[I]).FileAttr);
          case TFileInfo(FList[I]).Action of
            fcaDelete: SubItems.Add(rsOperationTypeDel);
            fcaTrash: SubItems.Add(rsOperationTypeTrash);
            fcaNone: SubItems.Add(rsOperationTypeNothing);
          end;
        end;
        FCorrespondance[J] := I;
        Inc(J);
      end;
    end;
  finally
    ListViewAction.Items.EndUpdate;
  end;
end;

procedure TFormFileList.ListViewActionChange(Sender: TObject;
  Item: TListItem; Change: TItemChange);
begin
  case TFileInfo(FList[FCorrespondance[Item.Index]]).Action of
    fcaDelete: Supprimer1.Checked := True;
    fcaTrash: Envoyerdanslacorbeille1.Checked := True;
    fcaNone: Nerienfaire1.Checked := True;
  end;
end;

procedure TFormFileList.Nerienfaire1Click(Sender: TObject);
begin
  TFileInfo(FList[FCorrespondance[ListViewAction.Selected.Index]]).Action := TAction((Sender as TMenuItem).Tag);
  UpdateList;
end;

procedure TFormFileList.Button1Click(Sender: TObject);
var I: Integer;
begin
  for I := 0 to FList.Count - 1 do
    if TFileInfo(FList[I]).Ask then
      TFileInfo(FList[I]).Action := fcaDelete;
  UpdateList;
end;

procedure TFormFileList.Button2Click(Sender: TObject);
var I: Integer;
begin
  for I := 0 to FList.Count - 1 do
    if TFileInfo(FList[I]).Ask then
      TFileInfo(FList[I]).Action := fcaTrash;
  UpdateList;
end;

procedure TFormFileList.Button3Click(Sender: TObject);
var I: Integer;
begin
  for I := 0 to FList.Count - 1 do
    if TFileInfo(FList[I]).Ask then
      TFileInfo(FList[I]).Action := fcaNone;
  UpdateList;
end;

procedure TFormFileList.PopupMenuActionPopup(Sender: TObject);
var B: boolean;
begin
  B := (ListViewAction.Selected <> nil) and
       (ListViewAction.Selected.Index in [Low(FCorrespondance)..High(FCorrespondance)]);
  Supprimer1.Visible := B;
  Envoyerdanslacorbeille1.Visible := B;
  Nerienfaire1.Visible := B;
end;

procedure TFormFileList.FormShow(Sender: TObject);
begin
  DataModuleApplication.SearchTrayIcon.Visibility :=
    DataModuleApplication.SearchTrayIcon.Visibility + [tvVisibleTaskBar];
end;

end.
