unit PluginsTypes;

interface

type
  TDirectoryMethod = procedure(out Directory: PChar; out Size: Integer); stdcall;
  TCleanMethod     = function(): Integer; stdcall;

  TSerialNumber = array [1..24] of Char;

  TPlugin = record
    pVersion: byte;
    pIdentificateur: TSerialNumber;
    pDescription: PChar;
    pLibType: (pltSystem, pltUser, pltIE, pltOther);
    pIsCheckDefault: boolean;
    pDirectoryFunc: TDirectoryMethod;
    pCleanFunc: TCleanMethod;
  end;
  PPlugin = ^TPlugin;

  TGetCountPlugins = function : Integer; stdcall;
  TGetPlugin       = function(const Index: Integer): PPlugin; stdcall;

implementation

end.
