library IE;

{$E xdl}

{$R *.res}

uses
  Windows,
  SysUtils,
  WinInet,
  PluginsTypes in 'PluginsTypes.pas';

const
  (* Constantes pour les fonctions de gestion du cache *)
  ERROR_CACHE_FIND_FAIL     = 0;
  ERROR_CACHE_FIND_SUCCESS  = 1;
  ERROR_FILE_NOT_FOUND      = 2;
  ERROR_ACCESS_DENIED       = 5;
  ERROR_INSUFFICIENT_BUFFER = 122;

  (* Types d'entre du cache *)
  EDITED_CACHE_ENTRY        = $8;
  SPARSE_CACHE_ENTRY        = $10000;

function CleanHistory(): Integer; stdcall;
var
  hFile: THandle;
  Entry: PInternetCacheEntryInfo;
  dwBuffer: Cardinal;
begin
  dwBuffer := 0;
  Entry := nil;
  hFile := FindFirstUrlCacheEntry(nil, Entry^, dwBuffer);
  if (hFile = ERROR_CACHE_FIND_FAIL) and
     (GetLastError = ERROR_INSUFFICIENT_BUFFER) then begin
     GetMem(Entry, dwBuffer);
     Entry.dwStructSize := dwBuffer;
     hFile := FindFirstUrlCacheEntry(nil, Entry^, dwBuffer);
  end;
  if (hFile <> ERROR_CACHE_FIND_FAIL) then begin
    repeat
      DeleteUrlCacheEntry(Entry.lpszSourceUrlName);

      if (not FindNextUrlCacheEntry(hFile, Entry^, dwBuffer)) and
         (GetLastError = ERROR_INSUFFICIENT_BUFFER) then begin
        ReallocMem(Entry, dwBuffer);
        Entry.dwStructSize := dwBuffer;
        FindNextUrlCacheEntry(hFile, Entry^, dwBuffer);
      end;
    until GetLastError = ERROR_NO_MORE_ITEMS;
  end;
  FreeMem(Entry);
  FindCloseUrlCache(hFile);
  result := -1;
end;

const
  Plugins: array[0..0] of TPlugin =
  ((pVersion: 0;
    pIdentificateur: '44E428-03090632-4BE0EDF8';
    pDescription: 'Historique d''Internet Explorer';
    pLibType: pltIE;
    pIsCheckDefault: true;
    pDirectoryFunc: nil;
    pCleanFunc: CleanHistory));

function GetCountPlugins: Integer; stdcall;
begin
  result := High(Plugins) - Low(Plugins) + 1;
end;

function GetPlugin(const Index: Integer): PPlugin; stdcall;
begin
  result := @Plugins[Index];
end;

exports
  GetCountPlugins,
  GetPlugin;

end.
