program xdelwin;

{%ToDo 'xdelwin.todo'}

uses
  Windows,
  Forms,
  ShareMemUtils,
  SysUtils,
  SearchForm in 'SearchForm.pas' {FormSearch},
  OptionsForm in 'OptionsForm.pas' {FormOptions},
  DeleteFrame in 'DeleteFrame.pas' {AskOptionFrame: TFrame},
  AppModule in 'AppModule.pas' {DataModuleApplication: TDataModule},
  PluginsManager in 'PluginsManager.pas',
  PluginsTypes in 'PluginsTypes.pas',
  OptionsManager in 'OptionsManager.pas',
  LogManager in 'LogManager.pas',
  SearchObject in 'SearchObject.pas',
  GroupEditForm in 'GroupEditForm.pas' {FormGroupEdit},
  SearchObjectThread in 'SearchObjectThread.pas',
  PluginsObjectThread in 'PluginsObjectThread.pas',
  FileListForm in 'FileListForm.pas' {FormFileList},
  SplashForm in 'SplashForm.pas' {FormSplash},
  Resources in 'Resources.pas';

{$R *.res}

var
  FXDLMutex: TMutex;
  FXDLEvent: TEvent;

  splash: boolean;

begin
  FXDLMutex := TMutex.Create('XDLMUTEX');
  if not (GetLastError() = ERROR_ALREADY_EXISTS) then begin

  splash := not (FindCmdLineSwitch('nosplash') or FindCmdLineSwitch('silent'));

  if(splash) then FormSplash := TFormSplash.Create(Application)
             else FormSplash := nil;
  try
    if Assigned(FormSplash) then FormSplash.Show;
    Application.ProcessMessages;

    if Assigned(FormSplash) then FormSplash.Inc;
    Application.Initialize;
    Application.Title := 'X-Del for Windows';

    if Assigned(FormSplash) then FormSplash.Inc;
    Application.CreateForm(TDataModuleApplication, DataModuleApplication);
    if Assigned(FormSplash) then FormSplash.Inc;
    Application.CreateForm(TFormSearch, FormSearch);
    FormSearch.AutoStart  := FindCmdLineSwitch('start');
    FormSearch.AutoStop   := FindCmdLineSwitch('stop');
    FormSearch.Iconize    := FindCmdLineSwitch('minimize')
                          or FindCmdLineSwitch('silent');
    FormSearch.SilentMode := FindCmdLineSwitch('noask')
                          or FindCmdLineSwitch('silent');
    Application.ShowMainForm := not FormSearch.Iconize;

    FormSearch.InitializeSoftware;
    if Assigned(FormSplash) then FormSplash.Close;
  finally
    FreeAndNil(FormSplash);
  end;
  Application.Run;
  end else begin
    FXDLEvent := TEvent.Create('XDLEVENT', False);
    FXDLEvent.Signal;
    FXDLEvent.Free;
  end;

  FXDLMutex.Free;
end.
